SystemOrganization addCategory: #OrionBrowser!
SystemOrganization addCategory: #'OrionBrowser-Test'!

!ASMethod methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 10:17'!
addInvocationTo: aMethod inModel: aModelVersion

	(ASActionAddInvocation new
		antaresModel: aModelVersion;
		from: self ;
		to: aMethod ;
		signature: aMethod signature)
	manualRun. ! !

!ASMethod methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 10:43'!
addReferenceTo: aClass inModel: aModelVersion

	(ASActionAddReference new
		antaresModel: aModelVersion;
		from: self ;
		entity: self ;
		to: aClass )
	manualRun. ! !

!ASMethod methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:08'!
deleteInModel: aModelVersion

	(ASActionRemoveMethod new
		antaresModel: aModelVersion ;
		entity: self )
	manualRun. ! !

!ASMethod methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:03'!
moveMethodTo: aClass inModel: aModelVersion

	(ASActionMoveMethod new
		antaresModel: aModelVersion ;
		entity: self ;
		newContainer: aClass )
	manualRun. ! !

!ASInvocation methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:13'!
deleteInModel:  aModelVersion
	(ASActionRemoveInvocation new
		antaresModel: aModelVersion;
		entity: self )
	manualRun. 
! !

!ASPackage methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 09:49'!
addClassNamed: aString inModel: aModelVersion
self flag: #fixme. "instead of package: should use entity: . For this need to fix ASActionAddClass"
	aString  ifNotNil: [ 
		(ASActionAddClass new
			antaresModel: aModelVersion ;
			package: self ;
			stringName: aString )
		manualRun ]! !

!ASPackage methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:10'!
deleteInModel: aModelVersion

	(ASActionRemovePackage new
		antaresModel: aModelVersion ;
		entity: self )
	manualRun. ! !

!ASPackage methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 10:56'!
mergePackage: aPackage inModel: aModelVersion

	(ASActionMergePackage  new
		antaresModel: aModelVersion ;
		entity: self ;
		newContainer: aPackage )
	manualRun. 
! !

!ASInheritance methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:13'!
deleteInModel:  aModelVersion
	(ASActionRemoveInheritance new
		antaresModel: aModelVersion;
		entity: self )
	manualRun. 
! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 09:33'!
addAttributNamed: aString inModel: aModelVersion
self flag: #todo. "maybe should return the action, not manuallyRun it."
	aString  ifNotNil: [ 
		(ASActionAddAttribute new
			antaresModel: aModelVersion ;
			entity: self ;
			stringName: aString )
		manualRun ]! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 10:11'!
addMethodNamed: aString inModel: aModelVersion

	aString  ifNotNil: [ 
		(ASActionAddMethod new
			antaresModel: aModelVersion ;
			containerClass: self ;
			stringName: aString )
		manualRun ]! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 10:03'!
addSuperClass: newSuperClass inModel: aModelVersion 
self flag: #fixme. "remove child: . For this need to fix ASActionAddInheritance"
	(ASActionAddInheritance new
		antaresModel: aModelVersion ;
		child: self ;
		entity: self ;
		parent: newSuperClass )
	manualRun. ! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 10:12'!
changeSuperClassTo: newSuperClass inModel: aModelVersion 

	(ASActionReplaceInheritance new 
			antaresModel: self antaresModel; 
			child: self ;
			entity: self ;
			parent: newSuperClass) 
			manualRun! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:07'!
deleteInModel: aModelVersion

	(ASActionRemoveClass new
		antaresModel: aModelVersion ;
		entity: self )
	manualRun. 
! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:02'!
moveClassTo: aPackage inModel: aModelVersion

	(ASActionMoveClass new
		antaresModel: aModelVersion ;
		entity: self ;
		newContainer: aPackage )
	manualRun. 
! !

!ASReference methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:14'!
deleteInModel:  aModelVersion
	(ASActionRemoveReference new
		antaresModel: aModelVersion;
		entity: self )
	manualRun. ! !

TestCase subclass: #OrionBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser-Test'!

!ASAttribute methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:05'!
deleteInModel: aModelVersion

	(ASActionRemoveAttribute new
		antaresModel: aModelVersion ;
		entity: self )
	manualRun. 
! !

!ASAttribute methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:00'!
moveAttributeTo: aClass inModel: aModelVersion

	(ASActionMoveAttribute  new
		antaresModel: aModelVersion ;
		entity: self ;
		newContainer: aClass )
	manualRun. 
! !

!ASModel methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 10:42'!
addPackageNamed: aString

	aString notNil ifTrue: [ 
		(ASActionAddPackage new
			antaresModel: self;
			stringName: aString )
		manualRun ]! !

ASAnnouncement subclass: #ASEntityBuffered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

Object subclass: #ASBrowser
	instanceVariableNames: 'selectedVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

!ASBrowser class methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:36'!
open 

	self new browser openOn: ASSystem root first! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
actionsFor: each
	|posAction elements listOfAct |

	elements :=  each selection mooseInterestingEntity.
	posAction := (((ASAction withAllSubclasses flatCollect: [:act | Pragma allNamed: #AntaresActionFor: in: act class])
					select:[:e | e arguments includes: elements class asString asSymbol]) collect:[:e | e methodClass soleInstance]) asOrderedCollection.
	listOfAct := OrderedCollection new.
	posAction do:[:ie | 
						|depend|
						depend := ie needs: elements.
						depend isNil 
							ifTrue:[
								listOfAct add:(
								(GLMAction new)
									action:[:anAct | 
										elements currentContext isModifiable ifTrue:[
											ie new entity: elements; antaresModel: elements currentContext; manualRun.
											elements currentContext system announcer announce: ASModelChanged]
										ifFalse:[
											ie new entity:elements; runOnNewVersionFrom: elements currentContext.
											elements currentContext system announcer announce: ASModelAdded
										]
									];
									title:ie description;
									yourself).]
							ifFalse:[
								depend do:[:anEl |
									listOfAct add:(
									(GLMAction new)
										action:[:anAct | 
											elements currentContext isModifiable ifTrue:[
												ie new entity:elements; to:anEl; antaresModel: elements currentContext; manualRun.
												elements currentContext system announcer announce: ASModelChanged]
											ifFalse:[
												ie new entity:elements; to:anEl; runOnNewVersionFrom: elements currentContext.
												elements currentContext system announcer announce: ASModelAdded]
										];
										title:anEl mooseName;
										category:ie description;
										yourself).]].				
				].
	^listOfAct.! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
browser
	"
		self new browser openOn: ASSystem root
	"
	| browser  |
	
	browser := GLMTabulator new.
	
	browser column: #models span: 1; column: [:c | c row:#versions; row: #changes] span: 1; column: #categories span: 4.
	(browser transmit) to: #models; andShow: [:b |
		b list
			format:[:system | system name];
			display: [:each | each ].
	].
	
	(browser transmit) from: #models; to: #versions; andShow: [:b | 
		b tree
			allExpanded;
			format:[:system | system name];
			display: [:each | each antaresModels select:[:om | om parentModel = nil]];
			children: [:each | each childrenModel];
			act: [:each | each selection inspect] entitled: 'inspect';
			act: [:each | |new|
				new := each selection createNewChildVersion. ASSystem announcer announce: ASModelAdded. browser announce: ASAnnouncement] entitled: 'create a child version';
			act: [:each | each selection delete. ASSystem announcer announce: ASModelRemoved. browser announce: ASAnnouncement] entitled: 'delete'.
	].
	(browser transmit) to: #changes; from: #versions; andShow: [:b |
		b list
			display: [:each | each changes];
			title: [ :each | each changes size asString, ' changes'].
	].
	(browser transmit) to: #categories; from: #versions; andShow: [:b |
		b finder
			show: [:a |
				a custom: (self groupList).
				a custom: self entityNavigation.
			].
	 ].
	browser subscribe: ASAnnouncement do: [browser update].
	^ browser! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 1/16/2013 10:13'!
displayFor: anObject
	| entity pragmaValueAssociations |
	entity := anObject mooseInterestingEntity.
	pragmaValueAssociations := entity complexPropertyPragmas collect: [ :pragma | 
		pragma -> (anObject mooseInterestingEntity perform: pragma selector) mooseInterestingEntity ].
	^ (pragmaValueAssociations
		reject: [ :association | 
			association value isNil or: [ 
				association value isCollection and: [ 
					association value isEmpty ] ] ])
		sorted: [:a :b | 
			(a key argumentAt: 1) asLowercase asString < (b key argumentAt: 1) asLowercase asString ]! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 1/16/2013 10:26'!
entityNavigation
	^ GLMListPresentation new
			title: 'Navigation';
			display: [ :anObject | |entity |
				entity := anObject mooseInterestingEntity.
				(entity mooseInterestingEntity isKindOf: FAMIXEntity) ifFalse:[self selectedVersion: entity] ifTrue:[entity currentContext: self selectedVersion.].
				self displayFor: entity value.
			];
			when: [:input | input mooseInterestingEntity isCollection not or: [input mooseInterestingEntity isKindOf: MooseModel] ];
			dynamicActionsOnSelection: [ :list | list selection mooseInterestingEntity mooseFinderActions ].! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
groupList
	^ GLMListPresentation new
			beMultiple;
			showOnly: 50;
			display: [:e | e mooseInterestingEntity];
			send: [:each | each isNil ifTrue: [nil] ifFalse: [each asMooseGroup]];
			format: #mooseName;
			title: [ :each | each mooseInterestingEntity size asString, ' items'];
			when: [:input | (input mooseInterestingEntity isKindOf: MooseGroup) or:[
					(input mooseInterestingEntity isKindOf: Collection) and:[(input mooseInterestingEntity isKindOf: ByteSymbol)not]]];
			dynamicActionsOnSelection: [ :list | OrderedCollection new 
					addAll: list selection mooseInterestingEntity mooseFinderActions;
					addAll: (self actionsFor: list);
					yourself].
				
	! !

!ASBrowser methodsFor: 'accessing' stamp: 'janniklaval 12/23/2012 08:25'!
selectedVersion
	^ selectedVersion! !

!ASBrowser methodsFor: 'accessing' stamp: 'janniklaval 12/23/2012 08:25'!
selectedVersion: anObject
	selectedVersion := anObject! !

Object subclass: #OrionBrowser
	instanceVariableNames: 'selectedVersion actionDict browser entityInSummary entityInBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

!OrionBrowser class methodsFor: 'as yet unclassified' stamp: 'na 1/19/2013 12:46'!
open 

	self new browser openOn: ASSystem root! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 2/21/2013 16:55'!
browser

	browser := GLMTabulator new.
	
	browser
		title: 'Orion Browser' ;
		column: [:c | c
				row:  #models ;
				row: #buffer size: 60 ]  span: 2 ;
		column: #packages  span: 2 ;
		column: #classes  span: 2 ;
		column: [:c | c
				row:  #attributes ;
				row:  #methods ]   span: 2 ;
		column: #links  span: 2 ;
		column: #summary span: 3.

	self
		browserModels ;
		browserBuffer ;
		browserPackages ;
		browserClasses ;
		browserAttributes ;
		browserMethods ;
		browserLinks ;
		browserSummary.
	
	browser subscribe: ASAnnouncement do: [ browser update].
	^ browser! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:05'!
browserAttributes
	(browser transmit) to: #attributes; from: #classes; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity attributes )  sorted: [:c1 :c2 | c1 name < c2 name] ];
			title: [ :each | ' Attributes'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;
		
			selectionAct: [:list | list selection deleteInModel: selectedVersion] entitled: 'Remove' ;
			selectionAct: [:list | list selection moveAttributeTo: entityInBuffer inModel: selectedVersion] entitled: 'Move to buffered class'.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 09:53'!
browserBuffer

	(browser transmit) to: #buffer; from: #packages port: #strongSelection; when: #notNil; andShow: [:a |
		a list
			display: [:anEntity | entityInBuffer := anEntity. {anEntity} ];
			title: 'Buffered'
	].

	(browser transmit) to: #buffer; from: #classes port: #strongSelection; when: #notNil; andShow: [:a |
		a list
			display: [:anEntity | entityInBuffer := anEntity. {anEntity} ];
			title: 'Buffered'
	].

	(browser transmit) to: #buffer; from: #methods port: #strongSelection; when: #notNil; andShow: [:a |
		a list
			display: [:anEntity | entityInBuffer := anEntity. {anEntity} ];
			title: 'Buffered'
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:17'!
browserClasses

	(browser transmit) to: #classes; from: #packages; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity classes)  sorted: [:c1 :c2 | c1 name < c2 name]];
			title: [ :each | ' Classes'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;
	
			selectionAct:  [:list | list selection addSuperClass: entityInBuffer inModel: selectedVersion]  entitled: 'Add inheritance from the buffered class' ;
			selectionAct:  [:list | list selection changeSuperClassTo: entityInBuffer inModel: selectedVersion]  entitled: 'Change super class for the buffered class' ;
			selectionAct:  [:list | list selection addAttributNamed: (self getNameDialog:  'New attribute name') inModel: selectedVersion]  entitled: 'Add attribute' ;
			selectionAct:  [:list | list selection addMethodNamed: (self getNameDialog:  'New method name') inModel: selectedVersion]  entitled: 'Add method' ;
			selectionAct: [:list | list selection deleteInModel: selectedVersion] entitled: 'Remove' ;	
			selectionAct: [:list | list selection moveClassTo: entityInBuffer inModel: selectedVersion] entitled: 'Move to buffered package' .
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:11'!
browserLinks

	"{#classes . #methods . #attributes} do: [:srcPanel |"

	(browser transmit) to: #links ; from: #classes ; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			title: 'Links' ;
			display: [ :anObject | (((anObject incomingReferences) union: (anObject superInheritances  )) union: (anObject subInheritances) ) sorted: [:x :y | x mooseName < y mooseName]] ;
			 
			format: [:aProp | (aProp asString)];
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;

			selectionAct:  [:list | list selection deleteInModel: selectedVersion]  entitled: 'Remove the Link'.
		].
	

	
	(browser transmit) to: #links ; from: #methods ; andShow:[:b | | gmlList |
		gmlList := b list.
		gmlList
			title: 'Links' ;
			display: [ :anObject | (anObject outgoingReferences ) 
					union: ((anObject incomingInvocations) union: (anObject outgoingInvocations  )) ] ;
			sorted: [:x :y | x mooseName < y mooseName] ;
			format: [:aProp | (aProp asString)];
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;
			
			selectionAct:  [:list | self remove:( list selection)]  entitled: 'Remove the Link'.
		].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:08'!
browserMethods
	(browser transmit) to: #methods; from: #classes; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity methods)  sorted: [:c1 :c2 | c1 name < c2 name] ];
			title: [ :each | 'Methods'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;

			 selectionAct: [:list | list selection deleteInModel: selectedVersion] entitled: 'Remove' ;
			selectionAct: [:list | list selection moveMethodTo: entityInBuffer inModel: selectedVersion] entitled: 'Move to the buffered class' ;
			selectionAct: [:list | list selection addReferenceTo: entityInBuffer inModel: selectedVersion] entitled: 'Add reference to the buffered class' ;
			selectionAct: [:list | list selection addInvocationTo: entityInBuffer inModel: selectedVersion] entitled: 'Add invocation to the buffered method'.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:17'!
browserModels

	(browser transmit) to: #models; andShow: [:b | | gmlTree |
		gmlTree := b tree.
		gmlTree
			allExpanded;
			display: [:systems | systems flatCollect: [:aSystem | aSystem antaresModels select:[:versions | versions parentModel isNil]]];
			format:[:aVersion | aVersion name];
			children: [:aVersion | aVersion childrenModel] ;

			selectionAct: [:list | list selection inspect] entitled:  'Inspect';

			selectionAct: [:theList | 
						theList selection createNewChildVersion.
						browser announce: ASAnnouncement]
				entitled: 'Create a child version' ;

			selectionAct: [:theList | 
						theList selection delete.
						browser announce: ASAnnouncement]
				entitled: 'Delete version'  ;

			selectionAct: [:list | list addPackageNamed: (self getNameDialog:  'New package name')] entitled: 'Add a package'.	

		self	versionChangesPane: gmlTree.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:17'!
browserPackages

	(browser transmit) to: #packages ; from:#models; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:model |
				self selectedVersion: model.
				(model allWithType: ASPackage) sorted: [:c1 :c2 | c1 name < c2 name] ] ;
			title: [ :each | ' Packages'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;
			selectionAct: [:list |  list selection addClassNamed: (self getNameDialog:  'New class name') inModel: selectedVersion]  entitled: 'Add a class' ;
			selectionAct: [:list | list selection deleteInModel: selectedVersion] entitled: 'Remove' ;
			selectionAct: [:list | list selection mergePackage: entityInBuffer inModel: selectedVersion] entitled: 'Merge with buffered package' .		
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 1/29/2013 18:06'!
browserSummary

	{#models . #packages .  #classes . #methods} do: [:srcPanel |

	(browser transmit) to: #summary ; from: srcPanel ; andShow: [:b |
		b  list
			noSelection ;
			title: 'Properties' ;
			display: [ :anObject | entityInSummary := anObject. anObject mooseInterestingEntity mooseDescription allPrimitiveAttributes ] ;
			sorted: [:x :y | x name < y name] ;
			format: [:aProp | aProp name ,  '= ' ,  ([(entityInSummary mooseInterestingEntity mmGetProperty: aProp) asString] on: Error do: ['error']) ]  ;
			when: [ :anObject | 
				(anObject mooseInterestingEntity isKindOf: MooseEntity) and: [
					anObject mooseInterestingEntity mooseDescription allPrimitiveAttributes notEmpty ]]]
		].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/21/2013 19:35'!
displayFor: anObject
	| entity pragmaValueAssociations |
	entity := anObject mooseInterestingEntity.
	pragmaValueAssociations := entity complexPropertyPragmas collect: [ :pragma | 
		pragma -> (anObject mooseInterestingEntity perform: pragma selector) mooseInterestingEntity ].
	^ (pragmaValueAssociations
		reject: [ :association | 
			association value isNil or: [ 
				association value isCollection and: [ 
					association value isEmpty ] ] ])
		sorted: [:a :b | 
			(a key argumentAt: 1) asLowercase asString < (b key argumentAt: 1) asLowercase asString ]! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/21/2013 19:50'!
formatFor: each
	^ (' ' join: ((each key argumentAt: 1) piecesCutWhereCamelCase collect: #capitalized)) , ' - ' , (each value mooseDisplayString contractTo: 50)! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:17'!
getNameDialog: aString
	
	| wizardControl  wizardPane textFieldPart defaultText |

	defaultText :=  '--Enter name--'.
	
	wizardControl := WizardControl new.
	wizardControl renderer: MerlinMorphicWizardRenderer new.
	
	wizardPane := WizardSinglePane new.
	
	textFieldPart := TextFieldPart  new
									inGroupboxNamed: aString;
									defaultValue: defaultText ;
									yourself.
	
	wizardPane row: textFieldPart associatedTo: #textFieldValue.
		
	wizardControl 
		addPane: wizardPane.
		
	wizardControl open. 
	((wizardControl wizardInformations at: #textFieldValue) = defaultText)
		ifTrue: [^ nil]
		ifFalse: [^ wizardControl wizardInformations at: #textFieldValue]! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/15/2013 15:31'!
selectedVersion
	^ selectedVersion! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/15/2013 15:31'!
selectedVersion: anObject
	selectedVersion := anObject! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/20/2013 11:41'!
versionChangesPane: gmlTree

		gmlTree
			selectionSpawn: [:theList |
				|tmpBrowser|
				tmpBrowser := GLMTabulator new row: #one; "initialExtent: 100@100 ;" yourself.
				tmpBrowser
					transmit to: #one ; andShow: [:brows |
						brows tree
							display: [:aVersion | aVersion changes select: [:chg | chg parentAction isNil]] ;
							children: [:aChange | aChange childrenActions];
							format:[:aChange | aChange printWorkspace];
							title: [ :aVersion | ' Changes in ' , (aVersion name)] ].
				tmpBrowser startOn: theList selection
				] entitled: 'List changes' .! !
